/*
 * Main.java
 *
 * Created on 20. jen 2006, 11:12
 *
 * @author Jiri Kremser
 * @version 1.0
 */

package ctverecku;

public class Main {

    private static int[][][] used;
    private static final int MAX_ITER = 2000;
    public static int[][][] boards = { {{3,2,1}, // 0
                                        {4,8,0},
                                        {5,6,7}},{{7,5,1}, // 1
                                                  {8,6,0},
                                                  {3,4,2}},{{8,7,6}, //2
                                                            {1,0,5},
                                                            {2,3,4}},{{1,4,0}, //3
                                                                      {6,2,5},
                                                                      {8,7,3}},{{5,8,4}, //4
                                                                                {0,6,7},
                                                                                {1,2,3}} /**/};/**/
    /*
                             ,{{0,8,6}, // 5
                              {3,7,1},
                              {4,5,2}},{{6,2,5}, // 6
                                        {8,7,1},
                                        {0,4,3}},{{6,0,1}, //7
                                                  {4,5,7},
                                                  {3,8,2}},{{2,3,7}, //8
                                                            {0,1,4},
                                                            {6,7,5}},{{5,4,1}, //9
                                                                      {6,0,7},
                                                                      {2,3,8}} };       
     */
    
    /**
     * problemSolution()
     *
     * heuristic type of heuristic (true - Manhattan)
     * check Visited type of search
     */
    public static boolean problemSolution(Node first, boolean heuristic, boolean checkVisited) {
        int i = 0, j = 500;
        Node akt = first;
        boolean end;
        Node.clearVisited();
        while (true) {
            if (checkVisited) {
                akt.visit();
            }
            if (i >= MAX_ITER) {
                System.out.println("\n*******************************************");
                System.out.println("  Solution of the problem has't been found");
                System.out.println("             in " + i + " steps");
                System.out.println("*******************************************\n");
                return false;                
            }
            end = akt.isEnd();
            if ( (end) || (akt.isSame(Node.noSolution))) {
                System.out.println("\n*******************************************");
                System.out.println("  Solution of the problem has" + ((end)?"":"'t") + " been found");
                if (end) {
                    System.out.println("             in " + i + " steps");
                    System.out.println("*******************************************\n");
                    System.out.println(akt);
                } else {
                    System.out.println("*******************************************\n");
                }                
                return (end) ? true : false;
            }
            
            System.out.println("STEP "+ i++ + ":");
            akt.setPrevNode(akt.getPrevNode());
            if (!akt.isSame(Node.noSolution)) {
                System.out.println(akt);
            }
            
            akt = new Node(Node.selectBest(akt.children(checkVisited),heuristic,checkVisited),first); // go to next node
        }
    }
        
    
    
    
    public static void runTest(boolean heuristic,boolean checkVisited) {
        int find = 0;
        for (int i = 0; i < boards.length; i++) {
            Node state = new Node(boards[i],null);
            if (problemSolution(state,heuristic,checkVisited)) {
                find++;
            }
            System.out.println(find + " solutions of " +  boards.length + " succeeded.");
            System.out.println("Efficinecy of " + ((heuristic)?"Manhattan":"first") +" heuristic -> " + ((double)find/boards.length));
            System.out.println();
            System.out.println();
            System.out.println();
            System.out.println();
            System.out.println();
            System.out.println();
            System.out.println();
        }
    }
    
        

    public static void main(String[] args) {     
        runTest(false,true);   
        runTest(true,true);     
    }
}
